diff --git a/packaging/smoke-local-web.sh b/packaging/smoke-local-web.sh
new file mode 100755
index 00000000..454560b5
--- /dev/null
+++ b/packaging/smoke-local-web.sh
@@ -0,0 +1,190 @@
+#!/usr/bin/env bash
+set -euo pipefail
+
+REPO_ROOT="$(cd "$(dirname "$0")/.." && pwd)"
+HOME_BEFORE="${HOME:?HOME must be set}"
+GEM_FILE="${1:-}"
+WEB_ARCHIVE="${2:-}"
+SANDBOX="$(mktemp -d -t hive-local-web-smoke-XXXXXX)"
+WEB_PID=""
+MANAGED_SERVICE_INSTALLED=0
+SERVICE_HOME=""
+
+cleanup() {
+  if [[ -n "$WEB_PID" ]] && kill -0 "$WEB_PID" 2>/dev/null; then
+    kill "$WEB_PID" 2>/dev/null || true
+    wait "$WEB_PID" 2>/dev/null || true
+  fi
+  if [[ "$MANAGED_SERVICE_INSTALLED" -eq 1 ]] && [[ -n "$SERVICE_HOME" ]]; then
+    HOME="$SERVICE_HOME" "$HIVE_BIN" uninstall --purge >/dev/null 2>&1 || true
+  fi
+  rm -rf "$SANDBOX"
+}
+trap cleanup EXIT
+
+if [[ -z "$GEM_FILE" ]]; then
+  (cd "$REPO_ROOT" && gem build hive.gemspec --output "$SANDBOX/hive-cli.gem")
+  GEM_FILE="$SANDBOX/hive-cli.gem"
+fi
+
+GEM_FILE="$(cd "$(dirname "$GEM_FILE")" && pwd)/$(basename "$GEM_FILE")"
+GEM_HOME="$SANDBOX/gems"
+DEFAULT_GEM_PATH="$(ruby -e 'puts Gem.default_path.join(File::PATH_SEPARATOR)')"
+export GEM_HOME GEM_PATH="$GEM_HOME:$DEFAULT_GEM_PATH"
+gem install "$GEM_FILE" --install-dir "$GEM_HOME" --bindir "$GEM_HOME/bin" --no-document
+HIVE_BIN="$GEM_HOME/bin/hive"
+VERSION="$("$HIVE_BIN" --version)"
+
+if [[ -z "$WEB_ARCHIVE" ]]; then
+  WEB_STAGE="$SANDBOX/web-stage"
+  mkdir -p "$WEB_STAGE"
+  cp -R "$REPO_ROOT/web/app" "$REPO_ROOT/web/bin" "$REPO_ROOT/web/config" \
+    "$REPO_ROOT/web/db" "$REPO_ROOT/web/public" "$REPO_ROOT/web/config.ru" \
+    "$REPO_ROOT/web/Gemfile" "$REPO_ROOT/web/Gemfile.lock" \
+    "$REPO_ROOT/web/Rakefile" "$WEB_STAGE/"
+  printf '%s\n' "$VERSION" > "$WEB_STAGE/.hive-web-version"
+  WEB_ARCHIVE="$SANDBOX/hive-web-$VERSION.tar.gz"
+  tar -C "$WEB_STAGE" -czf "$WEB_ARCHIVE" .
+fi
+
+WEB_ARCHIVE="$(cd "$(dirname "$WEB_ARCHIVE")" && pwd)/$(basename "$WEB_ARCHIVE")"
+export XDG_CONFIG_HOME="$SANDBOX/config"
+export XDG_DATA_HOME="$SANDBOX/data"
+export XDG_STATE_HOME="$SANDBOX/state"
+export XDG_CACHE_HOME="$SANDBOX/cache"
+export HOME="$SANDBOX/home"
+mkdir -p "$XDG_CONFIG_HOME" "$XDG_DATA_HOME" "$XDG_STATE_HOME" \
+  "$XDG_CACHE_HOME" "$HOME"
+
+ARCHIVE_SHA="$(ruby -rdigest -e 'puts Digest::SHA256.file(ARGV.fetch(0)).hexdigest' "$WEB_ARCHIVE")"
+GEM_HOME="$GEM_HOME" GEM_PATH="$GEM_HOME" ruby -I"$GEM_HOME/gems/hive-cli-$VERSION/lib" \
+  -rhive/web/app_bundle -e '
+    source = ARGV.fetch(0)
+    sha = ARGV.fetch(1)
+    copier = ->(_url, target) { FileUtils.cp(source, target) }
+    Hive::Web::AppBundle.new(
+      url: "https://example.invalid/hive-web.tar.gz",
+      sha256: sha,
+      downloader: copier
+    ).install!
+  ' "$WEB_ARCHIVE" "$ARCHIVE_SHA"
+
+PORT="$(ruby -rsocket -e 's = TCPServer.new("127.0.0.1", 0); puts s.addr[1]; s.close')"
+"$HIVE_BIN" web --bind 127.0.0.1 --port "$PORT" >"$SANDBOX/web.log" 2>&1 &
+WEB_PID=$!
+
+READY=0
+for _attempt in $(seq 1 60); do
+  if curl -fsS "http://127.0.0.1:$PORT/health" >"$SANDBOX/health.json" 2>/dev/null; then
+    READY=1
+    break
+  fi
+  kill -0 "$WEB_PID" 2>/dev/null || break
+  sleep 1
+done
+
+if [[ "$READY" -ne 1 ]]; then
+  cat "$SANDBOX/web.log" >&2
+  exit 1
+fi
+
+grep -qxF "$VERSION" "$XDG_DATA_HOME/hive/web/.hive-web-version"
+test -d "$XDG_DATA_HOME/hive/web-gems"
+test -d "$XDG_STATE_HOME/hive/web-storage"
+
+kill "$WEB_PID"
+wait "$WEB_PID" || true
+WEB_PID=""
+
+# Exercise the platform manager with the packaged binary, not just the
+# foreground Rails process. systemd-user resolves units from the login user's
+# real home, while launchd loads the explicit plist path and can remain under
+# the sandbox home.
+SERVICE_HOME="$HOME"
+if [[ "$(uname -s)" == "Linux" ]]; then
+  SERVICE_HOME="${HOME_BEFORE:-${RUNNER_HOME:-}}"
+  if [[ -z "$SERVICE_HOME" ]]; then
+    echo "managed web smoke: real Linux home is unavailable" >&2
+    exit 1
+  fi
+  if ! HOME="$SERVICE_HOME" systemctl --user show-environment >/dev/null 2>&1; then
+    echo "managed web smoke: systemd-user is unavailable" >&2
+    exit 1
+  fi
+fi
+mkdir -p "$SERVICE_HOME/Library/Logs"
+
+# The RubyGems wrapper needs the isolated GEM_HOME when a service manager
+# starts it outside this shell. HIVE_INVOKED_BIN makes both units persist this
+# stable wrapper, matching the normal install.sh/Homebrew wrapper contract.
+SERVICE_BIN_DIR="$SANDBOX/service-bin"
+mkdir -p "$SERVICE_BIN_DIR"
+SERVICE_HIVE_BIN="$SERVICE_BIN_DIR/hive"
+printf '%s\n' \
+  '#!/usr/bin/env bash' \
+  "export GEM_HOME=\"$GEM_HOME\"" \
+  "export GEM_PATH=\"$GEM_PATH\"" \
+  "exec \"$HIVE_BIN\" \"\$@\"" >"$SERVICE_HIVE_BIN"
+chmod +x "$SERVICE_HIVE_BIN"
+
+# `hive setup` diagnoses command presence/auth before it mutates. Supply
+# deterministic acceptance shims for tools whose real credentials do not
+# belong on release runners; git/ruby and both service managers remain real.
+PREREQ_BIN="$SANDBOX/prereq-bin"
+mkdir -p "$PREREQ_BIN"
+for tool in qmd gh claude codex tmux node npm sqlite3 cosign; do
+  printf '%s\n' '#!/usr/bin/env bash' 'echo "3.4.0"' 'exit 0' >"$PREREQ_BIN/$tool"
+  chmod +x "$PREREQ_BIN/$tool"
+done
+SETUP_PROJECT="$SANDBOX/setup-project"
+mkdir -p "$SETUP_PROJECT"
+git -C "$SETUP_PROJECT" init -q
+
+MANAGED_SERVICE_INSTALLED=1
+(
+  cd "$SETUP_PROJECT"
+  HOME="$SERVICE_HOME" \
+    PATH="$PREREQ_BIN:$PATH" \
+    HIVE_INVOKED_BIN="$SERVICE_HIVE_BIN" \
+    HIVE_WEB_BIND=127.0.0.1 \
+    HIVE_WEB_PORT="$PORT" \
+    "$HIVE_BIN" setup --no-init --json
+) >"$SANDBOX/setup.json"
+jq -e '.schema == "hive-setup" and .ok == true and
+       ([.phases[] | select(.name == "web_readiness" and .ok == true)] | length == 1)' \
+  "$SANDBOX/setup.json" >/dev/null
+
+READY=0
+for _attempt in $(seq 1 60); do
+  if HOME="$SERVICE_HOME" HIVE_INVOKED_BIN="$SERVICE_HIVE_BIN" "$HIVE_BIN" web status \
+       --bind 127.0.0.1 --port "$PORT" --json >"$SANDBOX/web-status.json" 2>/dev/null; then
+    READY=1
+    break
+  fi
+  sleep 1
+done
+if [[ "$READY" -ne 1 ]]; then
+  cat "$SANDBOX/web-status.json" >&2 2>/dev/null || true
+  exit 1
+fi
+jq -e '.schema == "hive-web-status" and .ready == true' "$SANDBOX/web-status.json" >/dev/null
+
+HOME="$SERVICE_HOME" HIVE_INVOKED_BIN="$SERVICE_HIVE_BIN" \
+  "$HIVE_BIN" daemon repair --json >"$SANDBOX/daemon-repair.json"
+jq -e '.schema == "hive-daemon-maintenance" and .ok == true' "$SANDBOX/daemon-repair.json" >/dev/null
+HOME="$SERVICE_HOME" HIVE_INVOKED_BIN="$SERVICE_HIVE_BIN" \
+  "$HIVE_BIN" daemon restart --json >"$SANDBOX/daemon-restart.json"
+jq -e '.schema == "hive-daemon-maintenance" and .ok == true' "$SANDBOX/daemon-restart.json" >/dev/null
+
+HOME="$SERVICE_HOME" HIVE_INVOKED_BIN="$SERVICE_HIVE_BIN" "$HIVE_BIN" web stop \
+  --bind 127.0.0.1 --port "$PORT" --json >"$SANDBOX/web-stop.json"
+jq -e '.schema == "hive-web-status" and .operation == "stop" and .ok == true' \
+  "$SANDBOX/web-stop.json" >/dev/null
+
+HOME="$SERVICE_HOME" "$HIVE_BIN" uninstall --purge >"$SANDBOX/uninstall.log"
+MANAGED_SERVICE_INSTALLED=0
+test ! -e "$SERVICE_HOME/.config/systemd/user/hive-web.service"
+test ! -e "$SERVICE_HOME/Library/LaunchAgents/local.hive-web.plist"
+test ! -d "$XDG_DATA_HOME/hive/web"
+
+printf 'local web foreground and managed lifecycle passed at http://127.0.0.1:%s\n' "$PORT"
diff --git a/packaging/verify-release.sh b/packaging/verify-release.sh
index a66153ea..c82f74e2 100755
--- a/packaging/verify-release.sh
+++ b/packaging/verify-release.sh
@@ -28,7 +28,7 @@
 #   0   all verifications passed
 #   1   a verification step failed (script preserves the tmp prefix)
 #   2   bad arguments
-#   3   prerequisite missing (curl, ruby, jq, git)
+#   3   prerequisite missing (curl, ruby, jq, git, cosign)
 
 set -euo pipefail
 
@@ -57,7 +57,7 @@ EXIT CODES:
   0   all verifications passed
   1   a verification step failed (script preserves the tmp prefix)
   2   bad arguments
-  3   prerequisite missing (curl, ruby, jq, git)
+  3   prerequisite missing (curl, ruby, jq, git, cosign)
 HELP
 }
 
@@ -100,7 +100,7 @@ INSTALL_SH="$REPO_ROOT/install.sh"
 
 # ─── prerequisites ───────────────────────────────────────────────────
 
-for cmd in curl ruby jq git; do
+for cmd in curl ruby jq git cosign; do
   command -v "$cmd" >/dev/null 2>&1 || {
     echo "verify-release: missing prerequisite: $cmd" >&2
     exit 3
@@ -303,6 +303,48 @@ else
   fail "install-channel sidecar missing at $XDG_DATA_HOME/hive/install-channel"
 fi
 
+# Releases that expose the first-class setup command must also publish the
+# version-matched Rails asset in the same authenticated checksum manifest.
+# Older pinned releases are feature-detected and retain their historical gate.
+if "$XDG_BIN_HOME/hive" help setup >/dev/null 2>&1; then
+  step "matching local web release bundle"
+  RELEASE_BASE="https://github.com/ivankuznetsov/hive/releases/download/$HIVE_VERSION"
+  WEB_VERSION="${HIVE_VERSION#v}"
+  WEB_ASSET="hive-web-${WEB_VERSION}.tar.gz"
+  curl -fsSL --connect-timeout 10 --max-time 60 \
+    "$RELEASE_BASE/SHA256SUMS" -o "$PREFIX/web-SHA256SUMS"
+  curl -fsSL --connect-timeout 10 --max-time 60 \
+    "$RELEASE_BASE/SHA256SUMS.sig" -o "$PREFIX/web-SHA256SUMS.sig"
+  curl -fsSL --connect-timeout 10 --max-time 60 \
+    "$RELEASE_BASE/SHA256SUMS.pem" -o "$PREFIX/web-SHA256SUMS.pem"
+  if cosign verify-blob \
+       --certificate "$PREFIX/web-SHA256SUMS.pem" \
+       --signature "$PREFIX/web-SHA256SUMS.sig" \
+       --certificate-identity \
+         "https://github.com/ivankuznetsov/hive/.github/workflows/release.yml@refs/tags/$HIVE_VERSION" \
+       --certificate-oidc-issuer "https://token.actions.githubusercontent.com" \
+       "$PREFIX/web-SHA256SUMS" >/dev/null; then
+    ok "SHA256SUMS has an authenticated Hive release signature"
+  else
+    fail "SHA256SUMS signature verification failed"
+    exit 1
+  fi
+  curl -fsSL --connect-timeout 10 --max-time 120 \
+    "$RELEASE_BASE/$WEB_ASSET" -o "$PREFIX/$WEB_ASSET"
+  WEB_EXPECTED="$(awk -v asset="$WEB_ASSET" '$2 == asset || $2 == "*" asset { print $1; exit }' "$PREFIX/web-SHA256SUMS")"
+  WEB_ACTUAL="$(ruby -rdigest -e 'puts Digest::SHA256.file(ARGV.fetch(0)).hexdigest' "$PREFIX/$WEB_ASSET")"
+  if [[ -n "$WEB_EXPECTED" && "$WEB_EXPECTED" == "$WEB_ACTUAL" ]]; then
+    ok "$WEB_ASSET matches the signed release manifest"
+  else
+    fail "$WEB_ASSET is missing from, or mismatched with, SHA256SUMS"
+  fi
+  if tar -xOf "$PREFIX/$WEB_ASSET" ./.hive-web-version 2>/dev/null | grep -qx "$WEB_VERSION"; then
+    ok "$WEB_ASSET embeds version $WEB_VERSION"
+  else
+    fail "$WEB_ASSET has a missing or mismatched .hive-web-version"
+  fi
+fi
+
 # ─── 2. doctor ───────────────────────────────────────────────────────
 
 step "hive doctor"
diff --git a/test/e2e/lib/repro_script_writer.rb b/test/e2e/lib/repro_script_writer.rb
index f0f3c06d..a1421dc8 100644
--- a/test/e2e/lib/repro_script_writer.rb
+++ b/test/e2e/lib/repro_script_writer.rb
@@ -1,6 +1,7 @@
 require "fileutils"
 require "rbconfig"
 require "shellwords"
+require "uri"
 require_relative "paths"
 require_relative "path_safety"
 require_relative "sandbox_env"
@@ -118,6 +119,10 @@ module Hive
           emit_spawn_background(step)
         when "stop_process"
           emit_stop_process(step)
+        when "http_assert"
+          emit_http_assert(step)
+        when "http_form"
+          emit_http_form(step)
         else
           [ "# step #{step.position} skipped: kind=#{step.kind} (stateful)" ]
         end
@@ -129,6 +134,63 @@ module Hive
         ]
       end
 
+      def emit_http_assert(step)
+        url = expand_string(step.args.fetch("url"))
+        status = Integer(step.args.fetch("status", 200))
+        contains = step.args.key?("contains") ? expand_string(step.args["contains"]) : nil
+        timeout = (step.args["timeout"] || 10).to_f
+        ruby = [
+          "require 'net/http'",
+          "require 'uri'",
+          "uri = URI(#{url.inspect})",
+          "deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + #{timeout.inspect}",
+          "loop do",
+          "  begin",
+          "    response = Net::HTTP.start(uri.host, uri.port, open_timeout: 0.5, read_timeout: 1) { |http| http.get(uri.request_uri) }",
+          "    ok = response.code.to_i == #{status.inspect}",
+          ("    ok &&= response.body.include?(#{contains.inspect})" if contains),
+          "    exit 0 if ok",
+          "  rescue SystemCallError, Timeout::Error, Net::OpenTimeout, Net::ReadTimeout",
+          "  end",
+          "  break if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline",
+          "  sleep 0.2",
+          "end",
+          "abort('http_assert failed for #{url}')"
+        ].compact.join("\n")
+        [
+          "# step #{step.position} http_assert: #{url}",
+          Shellwords.join([ RbConfig.ruby, "-e", ruby ])
+        ]
+      end
+
+      def emit_http_form(step)
+        url = expand_string(step.args.fetch("url"))
+        csrf_from = expand_string(step.args.fetch("csrf_from", URI(url).merge("/").to_s))
+        form = expand(step.args.fetch("form")).transform_keys(&:to_s)
+        status = Integer(step.args.fetch("status", 302))
+        ruby = [
+          "require 'cgi'",
+          "require 'net/http'",
+          "require 'uri'",
+          "uri = URI(#{url.inspect})",
+          "csrf_uri = URI(#{csrf_from.inspect})",
+          "page = Net::HTTP.get_response(csrf_uri)",
+          "token = page.body.match(/<meta[^>]+name=[\\\"']csrf-token[\\\"'][^>]+content=[\\\"']([^\\\"']+)[\\\"']/)",
+          "abort('no CSRF token found') unless token",
+          "request = Net::HTTP::Post.new(uri)",
+          "request['X-CSRF-Token'] = CGI.unescapeHTML(token[1])",
+          "cookies = page.get_fields('set-cookie').to_a.map { |header| header.split(';', 2).first }",
+          "request['Cookie'] = cookies.join('; ') unless cookies.empty?",
+          "request.set_form_data(#{form.inspect})",
+          "response = Net::HTTP.start(uri.host, uri.port) { |http| http.request(request) }",
+          "abort(\"expected HTTP #{status}, got \#{response.code}\") unless response.code.to_i == #{status}"
+        ].join("\n")
+        [
+          "# step #{step.position} http_form: #{url}",
+          Shellwords.join([ RbConfig.ruby, "-e", ruby ])
+        ]
+      end
+
       def emit_cli(step, env_overrides: {})
         args = expand(step.args.fetch("args")).map(&:to_s)
         env = expand(step.args["env"] || {}).merge(env_overrides)
diff --git a/test/e2e/lib/scenario_parser.rb b/test/e2e/lib/scenario_parser.rb
index 3cd973d8..4faef80f 100644
--- a/test/e2e/lib/scenario_parser.rb
+++ b/test/e2e/lib/scenario_parser.rb
@@ -19,7 +19,7 @@ module Hive
       STEP_KINDS = %w[
         cli tui_keys tui_expect tui_refute state_assert json_assert seed_state write_file
         register_project wait_subprocess editor_action log_assert ruby_block
-        start_releases_stub spawn_background stop_process
+        start_releases_stub spawn_background stop_process http_assert http_form
       ].freeze
 
       REQUIRED_KEYS = {
@@ -36,7 +36,9 @@ module Hive
         "ruby_block" => %w[block],
         "start_releases_stub" => %w[tag],
         "spawn_background" => %w[id args],
-        "stop_process" => %w[id]
+        "stop_process" => %w[id],
+        "http_assert" => %w[url],
+        "http_form" => %w[url form]
       }.freeze
 
       def self.parse(path)
diff --git a/test/e2e/lib/step_executor.rb b/test/e2e/lib/step_executor.rb
index a1bc4cd0..656d2644 100644
--- a/test/e2e/lib/step_executor.rb
+++ b/test/e2e/lib/step_executor.rb
@@ -170,6 +170,12 @@ module Hive
         return unless step.args.key?("pick")
 
         actual = pick(doc, Array(step.args["pick"]))
+        if step.args.key?("matches")
+          expected = Regexp.new(expand_string(step.args["matches"]))
+          return if actual.to_s.match?(expected)
+
+          raise StepFailure.new(step, "expected #{step.args['pick'].inspect} to match #{expected.inspect}, got #{actual.inspect}")
+        end
         expected = expand(step.args["equals"])
         return if actual == expected
 
@@ -315,6 +321,77 @@ module Hive
         proc.stop
       end
 
+      def step_http_assert(step)
+        require "net/http"
+        require "uri"
+        uri = URI(expand_string(step.args.fetch("url")))
+        expected_status = Integer(step.args.fetch("status", 200))
+        expected_body = step.args.key?("contains") ? expand_string(step.args["contains"]) : nil
+        deadline = monotonic_time + (step.args["timeout"] || 10).to_f
+        last_error = nil
+        loop do
+          begin
+            response = Net::HTTP.start(
+              uri.host,
+              uri.port,
+              open_timeout: 0.5,
+              read_timeout: 1
+            ) { |http| http.get(uri.request_uri) }
+            return if response.code.to_i == expected_status &&
+                      (expected_body.nil? || response.body.include?(expected_body))
+
+            last_error = "HTTP #{response.code}; body did not satisfy the assertion"
+          rescue SystemCallError, Timeout::Error, Net::OpenTimeout, Net::ReadTimeout => e
+            last_error = "#{e.class}: #{e.message}"
+          end
+          break if monotonic_time >= deadline
+
+          sleep 0.2
+        end
+        raise StepFailure.new(
+          step,
+          "expected #{uri} to return #{expected_status}" \
+          "#{expected_body ? " containing #{expected_body.inspect}" : ""}; #{last_error}"
+        )
+      end
+
+      def step_http_form(step)
+        require "cgi"
+        require "net/http"
+        require "uri"
+        uri = URI(expand_string(step.args.fetch("url")))
+        csrf_uri = URI(expand_string(step.args.fetch("csrf_from", "#{uri.scheme}://#{uri.host}:#{uri.port}/")))
+        page = Net::HTTP.start(
+          csrf_uri.host,
+          csrf_uri.port,
+          open_timeout: 1,
+          read_timeout: 2
+        ) { |http| http.get(csrf_uri.request_uri) }
+        token_match = page.body.match(/<meta[^>]+name=["']csrf-token["'][^>]+content=["']([^"']+)["']/)
+        raise StepFailure.new(step, "no CSRF token found at #{csrf_uri}") unless token_match
+
+        request = Net::HTTP::Post.new(uri)
+        request["X-CSRF-Token"] = CGI.unescapeHTML(token_match[1])
+        cookies = page.get_fields("set-cookie").to_a.map { |header| header.split(";", 2).first }
+        request["Cookie"] = cookies.join("; ") unless cookies.empty?
+        request.set_form_data(expand(step.args.fetch("form")).transform_keys(&:to_s))
+        response = Net::HTTP.start(
+          uri.host,
+          uri.port,
+          open_timeout: 1,
+          read_timeout: 5
+        ) { |http| http.request(request) }
+        expected_status = Integer(step.args.fetch("status", 302))
+        return if response.code.to_i == expected_status
+
+        raise StepFailure.new(
+          step,
+          "expected POST #{uri} to return #{expected_status}, got #{response.code}"
+        )
+      rescue URI::InvalidURIError, SystemCallError, Timeout::Error, Net::OpenTimeout, Net::ReadTimeout => e
+        raise StepFailure.new(step, "POST #{uri || step.args['url']} failed: #{e.class}: #{e.message}")
+      end
+
       def step_tui_refute(step)
         tmux = @tmux_lifecycle.start_session
         anchor = expand_string(step.args.fetch("anchor"))
diff --git a/test/eval/support/codex_judge.rb b/test/eval/support/codex_judge.rb
index 2a35a56a..58eaeba7 100644
--- a/test/eval/support/codex_judge.rb
+++ b/test/eval/support/codex_judge.rb
@@ -1,6 +1,7 @@
 require "json"
 require "open3"
 require "timeout"
+require "hive/bounded_process"
 
 module Hive
   module Eval
@@ -43,9 +44,9 @@ module Hive
       private
 
       def capture(prompt)
-        Timeout.timeout(@timeout_sec) do
-          Open3.capture3(@command, "exec", "--json", prompt)
-        end
+        Hive::BoundedProcess.capture3(
+          @command, "exec", "--json", prompt, timeout: @timeout_sec
+        )
       end
 
       def prompt(text)
diff --git a/test/eval/support/personas.rb b/test/eval/support/personas.rb
index 13417cba..24dca1f8 100644
--- a/test/eval/support/personas.rb
+++ b/test/eval/support/personas.rb
@@ -1,6 +1,7 @@
 require "json"
 require "open3"
 require "timeout"
+require "hive/bounded_process"
 
 module Hive
   module Eval
@@ -36,9 +37,9 @@ module Hive
       private
 
       def capture(prompt)
-        Timeout.timeout(@timeout_sec) do
-          Open3.capture3(@command, "exec", "--json", prompt)
-        end
+        Hive::BoundedProcess.capture3(
+          @command, "exec", "--json", prompt, timeout: @timeout_sec
+        )
       end
 
       def prompt(bot_message)
diff --git a/test/integration/local_web_setup_test.rb b/test/integration/local_web_setup_test.rb
new file mode 100644
index 00000000..ce8f7a8f
--- /dev/null
+++ b/test/integration/local_web_setup_test.rb
@@ -0,0 +1,50 @@
+require "test_helper"
+require "json"
+require "hive/commands/init"
+require "hive/commands/setup"
+
+class LocalWebSetupIntegrationTest < Minitest::Test
+  include HiveTestHelper
+
+  class Diagnostics
+    def call = []
+  end
+
+  def test_setup_enables_the_registered_project_name_and_emits_one_json_document
+    with_xdg_home do |sandbox|
+      project = File.join(sandbox, "repo")
+      FileUtils.mkdir_p(project)
+      run!("git", "-C", project, "init", "-b", "main", "--quiet")
+      run!("git", "-C", project, "config", "user.email", "test@example.com")
+      run!("git", "-C", project, "config", "user.name", "Test")
+      File.write(File.join(project, "README.md"), "test\n")
+      run!("git", "-C", project, "add", ".")
+      run!("git", "-C", project, "commit", "-m", "initial", "--quiet")
+
+      capture_io { Hive::Commands::Init.new(project, force: true, json: false).call }
+      output = StringIO.new
+      setup = Hive::Commands::Setup.new(
+        project_root: project,
+        diagnostics: Diagnostics.new,
+        bundle_installer: -> { true },
+        daemon_installer: ->(_binary) { true },
+        daemon_status: ->(_binary) { { "ready" => true } },
+        web_installer: ->(_binary) { true },
+        web_status: -> { { "ready" => true, "url" => "http://127.0.0.1:4567" } },
+        json: true,
+        output: output
+      )
+
+      result = setup.call
+      document = JSON.parse(output.string)
+      registered = Hive::Config.project_for_path(project)
+      config = YAML.safe_load_file(File.join(project, ".hive-state", "config.yml"))
+
+      assert result.fetch("ok")
+      assert_equal result, document
+      assert_equal 1, output.string.lines.length
+      assert_equal File.basename(project), registered.fetch("name")
+      assert_equal true, config.dig("daemon", "enabled")
+    end
+  end
+end
diff --git a/test/integration/web_packaged_bootstrap_test.rb b/test/integration/web_packaged_bootstrap_test.rb
new file mode 100644
index 00000000..2f9c071a
--- /dev/null
+++ b/test/integration/web_packaged_bootstrap_test.rb
@@ -0,0 +1,56 @@
+require "test_helper"
+require "digest"
+require "rubygems/package"
+require "zlib"
+require "hive/web/app_bundle"
+
+class WebPackagedBootstrapIntegrationTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_custom_authenticated_bundle_bootstraps_from_outside_the_checkout
+    with_xdg_home do |sandbox|
+      archive = File.join(sandbox, "hive-web.tgz")
+      write_bundle(archive)
+      runner_calls = []
+      installer = Hive::Web::AppBundle.new(
+        url: "https://packages.example.invalid/hive-web.tgz",
+        sha256: Digest::SHA256.file(archive).hexdigest,
+        cli_root: File.expand_path("../..", __dir__),
+        downloader: ->(_url, target) { FileUtils.cp(archive, target) },
+        runner: ->(env, argv, chdir:) { runner_calls << [ env, argv, chdir ]; true }
+      )
+
+      Dir.chdir(sandbox) { installer.install! }
+
+      assert_equal 3, runner_calls.length
+      assert runner_calls.all? { |_env, _argv, dir| dir.start_with?(Hive::Paths.data_home) }
+      assert_equal Hive::Paths.web_gems_home, runner_calls.first[0].fetch("BUNDLE_PATH")
+      assert File.executable?(File.join(Hive::Paths.web_app_home, "bin", "rails"))
+      assert_equal Hive::VERSION,
+                   File.read(File.join(Hive::Paths.web_app_home, ".hive-web-version")).strip
+    end
+  end
+
+  private
+
+  def write_bundle(path)
+    files = {
+      ".hive-web-version" => "#{Hive::VERSION}\n",
+      "Gemfile" => "source \"https://rubygems.org\"\n",
+      "Gemfile.lock" => "GEM\n  specs:\n",
+      "config/application.rb" => "# application\n",
+      "bin/rails" => "#!/bin/sh\nexit 0\n"
+    }
+    Zlib::GzipWriter.open(path) do |gzip|
+      Gem::Package::TarWriter.new(gzip) do |tar|
+        tar.mkdir("config", 0o755)
+        tar.mkdir("bin", 0o755)
+        files.each do |name, body|
+          tar.add_file_simple(name, name == "bin/rails" ? 0o755 : 0o644, body.bytesize) do |io|
+            io.write(body)
+          end
+        end
+      end
+    end
+  end
+end
diff --git a/test/unit/agent_profile_test.rb b/test/unit/agent_profile_test.rb
index 7ef38f28..f26df47a 100644
--- a/test/unit/agent_profile_test.rb
+++ b/test/unit/agent_profile_test.rb
@@ -87,7 +87,7 @@ class AgentProfileTest < Minitest::Test
   def test_check_version_raises_when_version_check_times_out
     profile = make_profile(min_version: "1.0.0")
 
-    with_replaced_singleton_method(Timeout, :timeout, ->(_seconds, &_block) { raise Timeout::Error }) do
+    with_replaced_singleton_method(Hive::BoundedProcess, :capture3, ->(*_argv, **_kwargs) { raise Timeout::Error }) do
       err = assert_raises(Hive::AgentError) { profile.check_version! }
       assert_match(/version check timed out/, err.message)
     end
diff --git a/test/unit/bounded_process_test.rb b/test/unit/bounded_process_test.rb
new file mode 100644
index 00000000..6c7b131c
--- /dev/null
+++ b/test/unit/bounded_process_test.rb
@@ -0,0 +1,41 @@
+require "test_helper"
+require "timeout"
+require "hive/bounded_process"
+
+class BoundedProcessTest < Minitest::Test
+  def test_capture3_kills_a_hung_process_group
+    started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+
+    assert_raises(Timeout::Error) do
+      Hive::BoundedProcess.capture3(
+        RbConfig.ruby,
+        "-e",
+        "trap('TERM') {}; sleep 60",
+        timeout: 0.1
+      )
+    end
+
+    elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+    assert_operator elapsed, :<, 2
+  end
+
+  def test_run_kills_a_hung_process_group
+    started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+
+    assert_raises(Timeout::Error) do
+      Hive::BoundedProcess.run(
+        {},
+        RbConfig.ruby,
+        "-e",
+        "trap('TERM') {}; sleep 60",
+        chdir: Dir.pwd,
+        timeout: 0.1,
+        out: File::NULL,
+        err: File::NULL
+      )
+    end
+
+    elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+    assert_operator elapsed, :<, 2
+  end
+end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c29..f0838f59 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -519,7 +519,12 @@ class HiveCliTest < Minitest::Test
     require "hive/commands/web"
     captured = []
     recorder = Class.new do
-      define_method(:initialize) { |bind:, port:| captured << { bind: bind, port: port } }
+      define_method(:initialize) do |subcommand = nil, bind:, port:, unsafe:, force:, json:|
+        captured << {
+          subcommand: subcommand, bind: bind, port: port, unsafe: unsafe,
+          force: force, json: json
+        }
+      end
       define_method(:call) { captured << :called }
     end
 
@@ -527,14 +532,19 @@ class HiveCliTest < Minitest::Test
     Hive::Commands.send(:remove_const, :Web)
     Hive::Commands.const_set(:Web, recorder)
     begin
-      capture_io { Hive::CLI.start([ "web", "--bind", "0.0.0.0", "--port", "9123" ]) }
+      capture_io { Hive::CLI.start([ "web", "--bind", "0.0.0.0", "--port", "9123", "--unsafe" ]) }
     ensure
       Hive::Commands.send(:remove_const, :Web)
       Hive::Commands.const_set(:Web, original)
     end
 
-    assert_equal({ bind: "0.0.0.0", port: 9123 }, captured.first,
-                 "the --bind/--port flags must reach the web command")
+    assert_equal(
+      {
+        subcommand: nil, bind: "0.0.0.0", port: 9123, unsafe: true,
+        force: false, json: false
+      },
+      captured.first,
+                 "the --bind/--port/--unsafe flags must reach the web command")
     assert_equal :called, captured.last, "hive web must invoke the web command's #call"
   end
 
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788e..89ddaa2f 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -403,6 +403,41 @@ class HiveCommandsDaemonTest < Minitest::Test
     assert_match(/running \(pid 2468, uptime \d+s\)/, out)
   end
 
+  def test_repair_exposes_shared_maintenance_result_as_json
+    require "hive/commands/daemon/service_installer"
+    require "hive/web/daemon_maintenance"
+    result = {
+      "action" => "repair",
+      "ok" => true,
+      "message" => "daemon service written; no active agents were interrupted",
+      "completed_at" => Time.now.utc.iso8601,
+      "refused" => false,
+      "active_tasks" => [],
+      "forced_interruptions" => 0
+    }
+    maintenance = Object.new
+    maintenance.define_singleton_method(:call) { |_action| result }
+
+    out, _err = with_replaced_singleton_method(
+      Hive::Commands::Daemon::ServiceInstaller,
+      :new,
+      ->(**_kwargs) { Object.new }
+    ) do
+      with_replaced_singleton_method(
+        Hive::Web::DaemonMaintenance,
+        :new,
+        ->(**_kwargs) { maintenance }
+      ) do
+        capture_io { daemon("repair", json: true).call }
+      end
+    end
+
+    payload = JSON.parse(out)
+    assert_equal "hive-daemon-maintenance", payload.fetch("schema")
+    assert_equal "repair", payload.fetch("action")
+    assert_equal true, payload.fetch("ok")
+  end
+
 
   def test_reload_json_success_sends_hup_and_emits_envelope
     command = daemon("reload", json: true)
diff --git a/test/unit/commands/service_installer/base_test.rb b/test/unit/commands/service_installer/base_test.rb
index 09980af6..340552b1 100644
--- a/test/unit/commands/service_installer/base_test.rb
+++ b/test/unit/commands/service_installer/base_test.rb
@@ -331,6 +331,32 @@ class ServiceInstallerBaseTest < Minitest::Test
     assert_equal "local.hive-test", installer.launchd_label
   end
 
+  def test_launchd_loaded_job_without_pid_is_not_running
+    success = Struct.new(:success?).new(true)
+    installer = TestInstaller.new(
+      host_os: "darwin",
+      launchctl_available: true,
+      capture_runner: ->(_argv) {
+        [ "{\n  \"Label\" = \"local.hive-test\";\n  \"LastExitStatus\" = 1;\n}\n", "", success ]
+      }
+    )
+
+    refute installer.running?
+  end
+
+  def test_launchd_job_with_pid_is_running
+    success = Struct.new(:success?).new(true)
+    installer = TestInstaller.new(
+      host_os: "darwin",
+      launchctl_available: true,
+      capture_runner: ->(_argv) {
+        [ "{\n  \"PID\" = 4321;\n  \"Label\" = \"local.hive-test\";\n}\n", "", success ]
+      }
+    )
+
+    assert installer.running?
+  end
+
   # ── abstract subclass hooks ────────────────────────────────────────
   # A bare subclass that overrides NOTHING must raise NotImplementedError
   # for every identity/render hook, so a half-built subclass fails loudly
